#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

int main()
{
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);

    int n,a;
    long long rez=0;
    cin >> n;
    vector<int> jela(n),scenariji(n),recepti1(n);
    vector<pair<int,int>> recepti(n);
    for(int i=0; i<n; i++)
        cin >> jela[i];
    for(int i=0; i<n; i++){
        cin >> a;
        recepti[i].first=a;
        recepti[i].second=i+1;
        recepti1[i]=a;
    }

    for(int i=0; i<n; i++)
        cin >> scenariji[i];
    sort(jela.begin(),jela.end());
    sort(recepti.begin(),recepti.end());
    sort(scenariji.begin(),scenariji.end());
    sort(recepti1.begin(),recepti1.end());
    for(int i=0; i<n; i++){
        int trjelo=jela[i];
        for(int j=lower_bound(recepti1.begin(),recepti1.end(),trjelo)-recepti1.begin(); j<upper_bound(recepti1.begin(),recepti1.end(),trjelo)-recepti1.begin(); j++){
            int trbroj=recepti[j].second;
            rez+=upper_bound(scenariji.begin(),scenariji.end(),trbroj)-lower_bound(scenariji.begin(),scenariji.end(),trbroj);
        }


    }
    cout << rez;






    return 0;
}